Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSMorphGradient

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMorphGradient

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSMorphGradient

extends FSTransformObject

FSMorphGradient defines the control points that is used to specify how a gradient fill is displayed at the start and end of the shape morphing process.

Two or more control points are used to define how the colour changes across the gradient square.

Attributes
startRatio | The location of the control point across the gradient square at the start of the morphing process.
endRatio | The location of the control point across the gradient square at the end of the morphing process.
startColor | The colour at the control point at the start of the morphing process.
startColor | The colour at the control point at the end of the morphing process.

The location of the control point is defined by a ratio - a number between 0 and 255 that specifies the relative location in the square. For Linear Gradient Fills a ratio of zero is mapped to the left side of the gradient square and 255 is mapped to the right side of the square. For Radial Gradient Fills a ratio of zero is mapped to the centre of the gradient square and 255 is mapped to the edge of the largest circle that fits inside the gradient square.

FSMorphGradients are only used in FSDefineMorphShape objects which support transparent colours so values for all the colour channels must be specified in the FSColor objects.

When the Flash Player displays the gradient control points they are sorted by the ratio with the FSGradient object with the smallest ratio value displayed first.

# History

The FSMorphGradient class represents the MorphGradientRecord structure from the Macromedia Flash (SWF) File Format Specification. Shape morphing was introduced in Flash 3.

Constructor Summary
`FSMorphGradient(FSCoder coder)` Construct an FSMorphGradient object, initialising it with values decoded from an encoded object.
`FSMorphGradient(FSMorphGradient obj)` Constructs an FSMorphGradient object by copying values from an existing object.
`FSMorphGradient(int aStartRatio, int anEndRatio, FSColor aStartColor, FSColor anEndColor)` Constructs an FSMorphGradient object specifying the starting and ending ratios and colours.

Method Summary
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`FSColor` | `getEndColor()` Gets the colour at the end of the morphing process.
`int` | `getEndRatio()` Gets the ratio at the end of the morphing process.
`FSColor` | `getStartColor()` Gets the colour at the start of the morphing process.
`int` | `getStartRatio()` Gets the ratio at the start of the morphing process.
`int` | `length(FSCoder coder)`
`void` | `setEndColor(FSColor aColor)` Sets the colour at the end of the morphing process.
`void` | `setEndRatio(int aNumber)` Sets the ratio along the gradient square at the end of the morphing process.
`void` | `setStartColor(FSColor aColor)` Sets the colour at the start of the morphing process.
`void` | `setStartRatio(int aNumber)` Sets the ratio along the gradient square at the start of the morphing process.

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSMorphGradient

    public FSMorphGradient(FSCoder coder)

  Construct an FSMorphGradient object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSMorphGradient

    public FSMorphGradient(int aStartRatio,
                           int anEndRatio,
                           FSColor aStartColor,
                           FSColor anEndColor)

  Constructs an FSMorphGradient object specifying the starting and ending ratios and colours.

  Parameters:
    `aStartRatio` - the ratio along the gradient square at the start of the morphing process.
    `anEndRatio` - the ratio along the gradient square at the end of the morphing process.
    `aStartColor` - the colour at the starting control point.
    `anEndColor` - the colour at the ending control point.

### FSMorphGradient

    public FSMorphGradient(FSMorphGradient obj)

  Constructs an FSMorphGradient object by copying values from an existing object.

  Parameters:
    `obj` - an FSMorphGradient object.

Method Detail

### getStartRatio

    public int getStartRatio()

  Gets the ratio at the start of the morphing process.

  Returns:
    the start ratio.

### getEndRatio

    public int getEndRatio()

  Gets the ratio at the end of the morphing process.

  Returns:
    the end ratio.

### getStartColor

    public FSColor getStartColor()

  Gets the colour at the start of the morphing process.

  Returns:
    the start colour.

### getEndColor

    public FSColor getEndColor()

  Gets the colour at the end of the morphing process.

  Returns:
    the end colour.

### setStartRatio

    public void setStartRatio(int aNumber)

  Sets the ratio along the gradient square at the start of the morphing process.

  Parameters:
    `aNumber` - the starting ratio.

### setEndRatio

    public void setEndRatio(int aNumber)

  Sets the ratio along the gradient square at the end of the morphing process.

  Parameters:
    `aNumber` - the ending ratio.

### setStartColor

    public void setStartColor(FSColor aColor)

  Sets the colour at the start of the morphing process.

  Parameters:
    `aColor` - the start colour.

### setEndColor

    public void setEndColor(FSColor aColor)

  Sets the colour at the end of the morphing process.

  Parameters:
    `aColor` - the end colour.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSTransformObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Specified by:
    `appendDescription` in class `FSTransformObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Specified by:
    `length` in class `FSTransformObject`

### encode

    public void encode(FSCoder coder)

  Specified by:
    `encode` in class `FSTransformObject`

### decode

    public void decode(FSCoder coder)

  Specified by:
    `decode` in class `FSTransformObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD